Exiv2: Exiv2::Image Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Exiv2::Image Class Reference

Abstract base class defining the interface for an image. This is the top-level interface to the Exiv2 library. More...

`#include <image.hpp>`

Inheritance diagram for Exiv2::Image:

[legend]
Collaboration diagram for Exiv2::Image:

[legend]

List of all members.

## Public Types
typedef std::auto_ptr< Image > | AutoPtr
| Image auto_ptr type.
## Public Member Functions
Creators
| Image (int imageType, uint16_t supportedMetadata, BasicIo::AutoPtr io)
| Constructor taking the image type, a bitmap of the supported metadata types and an auto-pointer that owns an IO instance. See subclass constructor doc.
virtual | ~Image ()
| Virtual Destructor.
Manipulators
virtual void | readMetadata ()=0
| Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared.
virtual void | writeMetadata ()=0
| Write metadata back to the image.
virtual void | setExifData (const ExifData &exifData)
| Assign new Exif data. The new Exif data is not written to the image until the writeMetadata() method is called.
virtual void | clearExifData ()
| Erase any buffered Exif data. Exif data is not removed from the actual image until the writeMetadata() method is called.
virtual void | setIptcData (const IptcData &iptcData)
| Assign new IPTC data. The new IPTC data is not written to the image until the writeMetadata() method is called.
virtual void | clearIptcData ()
| Erase any buffered IPTC data. IPTC data is not removed from the actual image until the writeMetadata() method is called.
virtual void | setXmpPacket (const std::string &xmpPacket)
| Assign a raw XMP packet. The new XMP packet is not written to the image until the writeMetadata() method is called.
virtual void | clearXmpPacket ()
| Erase the buffered XMP packet. XMP data is not removed from the actual image until the writeMetadata() method is called.
virtual void | setXmpData (const XmpData &xmpData)
| Assign new XMP data. The new XMP data is not written to the image until the writeMetadata() method is called.
virtual void | clearXmpData ()
| Erase any buffered XMP data. XMP data is not removed from the actual image until the writeMetadata() method is called.
virtual void | setComment (const std::string &comment)
| Set the image comment. The new comment is not written to the image until the writeMetadata() method is called.
virtual void | clearComment ()
| Erase any buffered comment. Comment is not removed from the actual image until the writeMetadata() method is called.
virtual void | setMetadata (const Image &image)
| Copy all existing metadata from source Image. The data is copied into internal buffers and is not written to the image until the writeMetadata() method is called.
virtual void | clearMetadata ()
| Erase all buffered metadata. Metadata is not removed from the actual image until the writeMetadata() method is called.
virtual ExifData & | exifData ()
| Returns an ExifData instance containing currently buffered Exif data.
virtual IptcData & | iptcData ()
| Returns an IptcData instance containing currently buffered IPTC data.
virtual XmpData & | xmpData ()
| Returns an XmpData instance containing currently buffered XMP data.
virtual std::string & | xmpPacket ()
| Return a modifiable reference to the raw XMP packet.
void | writeXmpFromPacket (bool flag)
| Determine the source when writing XMP.
Accessors
bool | good () const
| Check if the Image instance is valid. Use after object construction.
virtual std::string | mimeType () const =0
| Return the MIME type of the image.
virtual const ExifData & | exifData () const
| Returns an ExifData instance containing currently buffered Exif data.
virtual const IptcData & | iptcData () const
| Returns an IptcData instance containing currently buffered IPTC data.
virtual const XmpData & | xmpData () const
| Returns an XmpData instance containing currently buffered XMP data.
virtual std::string | comment () const
| Return a copy of the image comment. May be an empty string.
virtual const std::string & | xmpPacket () const
| Return the raw XMP packet as a string.
virtual BasicIo & | io () const
| Return a reference to the BasicIo instance being used for Io.
AccessMode | checkMode (MetadataId metadataId) const
| Returns the access mode, i.e., the metadata functions, which this image supports for the metadata type metadataId.
bool | supportsMetadata (MetadataId metadataId) const
| Check if image supports a particular type of metadata. This method is deprecated. Use checkMode() instead.
bool | writeXmpFromPacket () const
| Return the flag indicating the source when writing XMP metadata.
## Protected Attributes
BasicIo::AutoPtr | io_
| Image data IO pointer.
ExifData | exifData_
| Exif data container.
IptcData | iptcData_
| IPTC data container.
XmpData | xmpData_
| XMP data container.
std::string | comment_
| User comment.
std::string | xmpPacket_
| XMP packet.

## Detailed Description

Abstract base class defining the interface for an image. This is the top-level interface to the Exiv2 library.

Image has containers to store image metadata and subclasses implement read and save metadata from and to specific image formats.
Most client apps will obtain an Image instance by calling a static ImageFactory method. The Image class can then be used to to read, write, and save metadata.

## Member Function Documentation

virtual void Exiv2::Image::readMetadata | ( |  | ) | `[pure virtual]`

Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared.

This method returns success even if no metadata is found in the image. Callers must therefore check the size of individual metadata types before accessing the data.

Exceptions:

  | Error | if opening or reading of the file fails or the image data is not valid (does not look like data of the specific image type).

Implemented in Exiv2::Cr2Image, Exiv2::CrwImage, Exiv2::JpegBase, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual void Exiv2::Image::writeMetadata | ( |  | ) | `[pure virtual]`

Write metadata back to the image.

All existing metadata sections in the image are either created, replaced, or erased. If values for a given metadata type have been assigned, a section for that metadata type will either be created or replaced. If no values have been assigned to a given metadata type, any exists section for that metadata type will be removed from the image.

Exceptions:

  | Error | if the operation fails

Implemented in Exiv2::Cr2Image, Exiv2::CrwImage, Exiv2::JpegBase, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual void Exiv2::Image::setExifData | ( | const ExifData & | exifData | ) | `[virtual]`

Assign new Exif data. The new Exif data is not written to the image until the writeMetadata() method is called.

Parameters:

  | exifData | An ExifData instance holding Exif data to be copied

Reimplemented in Exiv2::Cr2Image, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual void Exiv2::Image::setIptcData | ( | const IptcData & | iptcData | ) | `[virtual]`

Assign new IPTC data. The new IPTC data is not written to the image until the writeMetadata() method is called.

Parameters:

  | iptcData | An IptcData instance holding IPTC data to be copied

Reimplemented in Exiv2::Cr2Image, Exiv2::CrwImage, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual void Exiv2::Image::setXmpPacket | ( | const std::string & | xmpPacket | ) | `[virtual]`

Assign a raw XMP packet. The new XMP packet is not written to the image until the writeMetadata() method is called.

Subsequent calls to writeMetadata() write the XMP packet from the buffered raw XMP packet rather than from buffered parsed XMP data. In order to write from parsed XMP data again, use either writeXmpFromPacket(false) or setXmpData().

Parameters:

  | xmpPacket | A string containing the raw XMP packet.

virtual void Exiv2::Image::clearXmpPacket | ( |  | ) | `[virtual]`

Erase the buffered XMP packet. XMP data is not removed from the actual image until the writeMetadata() method is called.

This has the same effect as clearXmpData() but operates on the buffered raw XMP packet only, not the parsed XMP data.

Subsequent calls to writeMetadata() write the XMP packet from the buffered raw XMP packet rather than from buffered parsed XMP data. In order to write from parsed XMP data again, use either writeXmpFromPacket(false) or setXmpData().

virtual void Exiv2::Image::setXmpData | ( | const XmpData & | xmpData | ) | `[virtual]`

Assign new XMP data. The new XMP data is not written to the image until the writeMetadata() method is called.

Subsequent calls to writeMetadata() encode the XMP data to a raw XMP packet and write the newly encoded packet to the image. In the process, the buffered raw XMP packet is updated. In order to write directly from the raw XMP packet, use writeXmpFromPacket(true) or setXmpPacket().

Parameters:

  | xmpData | An XmpData instance holding XMP data to be copied

virtual void Exiv2::Image::clearXmpData | ( |  | ) | `[virtual]`

Erase any buffered XMP data. XMP data is not removed from the actual image until the writeMetadata() method is called.

This has the same effect as clearXmpPacket() but operates on the buffered parsed XMP data.

Subsequent calls to writeMetadata() encode the XMP data to a raw XMP packet and write the newly encoded packet to the image. In the process, the buffered raw XMP packet is updated. In order to write directly from the raw XMP packet, use writeXmpFromPacket(true) or setXmpPacket().

virtual void Exiv2::Image::setComment | ( | const std::string & | comment | ) | `[virtual]`

Set the image comment. The new comment is not written to the image until the writeMetadata() method is called.

Parameters:

  | comment | String containing comment.

Reimplemented in Exiv2::Cr2Image, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual void Exiv2::Image::setMetadata | ( | const Image & | image | ) | `[virtual]`

Copy all existing metadata from source Image. The data is copied into internal buffers and is not written to the image until the writeMetadata() method is called.

Parameters:

  | image | Metadata source. All metadata types are copied.

virtual ExifData& Exiv2::Image::exifData | ( |  | ) | `[inline, virtual]`

Returns an ExifData instance containing currently buffered Exif data.

The contained Exif data may have been read from the image by a previous call to readMetadata() or added directly. The Exif data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  modifiable ExifData instance containing Exif values

virtual IptcData& Exiv2::Image::iptcData | ( |  | ) | `[inline, virtual]`

Returns an IptcData instance containing currently buffered IPTC data.

The contained IPTC data may have been read from the image by a previous call to readMetadata() or added directly. The IPTC data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  modifiable IptcData instance containing IPTC values

virtual XmpData& Exiv2::Image::xmpData | ( |  | ) | `[inline, virtual]`

Returns an XmpData instance containing currently buffered XMP data.

The contained XMP data may have been read from the image by a previous call to readMetadata() or added directly. The XMP data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  modifiable XmpData instance containing XMP values

void Exiv2::Image::writeXmpFromPacket | ( | bool | flag | ) |

Determine the source when writing XMP.

Depending on the setting of this flag, writeMetadata() writes XMP from the buffered raw XMP packet or from parsed XMP data. The default is to write from parsed XMP data. The switch is also set by all functions to set and clear the buffered raw XMP packet and parsed XMP data, so using this function should usually not be necessary.

If Exiv2 was compiled without XMP support, the default for this flag is true and it will never be changed in order to preserve access to the raw XMP packet.

bool Exiv2::Image::good | ( |  | ) | const

Check if the Image instance is valid. Use after object construction.

Returns:
  true if the Image is in a valid state.

virtual std::string Exiv2::Image::mimeType | ( |  | ) | const`[pure virtual]`

Return the MIME type of the image.

Note:
  For each supported image format, the library knows only one MIME type. This may not be the most specific MIME type for that format. In particular, several RAW formats are variants of the TIFF format with the same magic as TIFF itself. Class TiffImage handles most of them and thus they all have MIME type "image/tiff", although a more specific MIME type may exist (e.g., "image/x-nikon-nef").

Implemented in Exiv2::Cr2Image, Exiv2::CrwImage, Exiv2::JpegImage, Exiv2::ExvImage, Exiv2::MrwImage, Exiv2::OrfImage, Exiv2::PngImage, Exiv2::RafImage, and Exiv2::TiffImage.

virtual const ExifData& Exiv2::Image::exifData | ( |  | ) | const`[inline, virtual]`

Returns an ExifData instance containing currently buffered Exif data.

The Exif data may have been read from the image by a previous call to readMetadata() or added directly. The Exif data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  read only ExifData instance containing Exif values

virtual const IptcData& Exiv2::Image::iptcData | ( |  | ) | const`[inline, virtual]`

Returns an IptcData instance containing currently buffered IPTC data.

The contained IPTC data may have been read from the image by a previous call to readMetadata() or added directly. The IPTC data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  modifiable IptcData instance containing IPTC values

virtual const XmpData& Exiv2::Image::xmpData | ( |  | ) | const`[inline, virtual]`

Returns an XmpData instance containing currently buffered XMP data.

The contained XMP data may have been read from the image by a previous call to readMetadata() or added directly. The XMP data in the returned instance will be written to the image when writeMetadata() is called.

Returns:
  modifiable XmpData instance containing XMP values

virtual BasicIo& Exiv2::Image::io | ( |  | ) | const`[inline, virtual]`

Return a reference to the BasicIo instance being used for Io.

This refence is particularly useful to reading the results of operations on a MemIo instance. For example after metadata has been modified and the writeMetadata() method has been called, this method can be used to get access to the modified image.

Returns:
  BasicIo instance that can be used to read or write image data directly.

Note:
  If the returned BasicIo is used to write to the image, the Image class will not see those changes until the readMetadata() method is called.

AccessMode Exiv2::Image::checkMode | ( | MetadataId | metadataId | ) | const

Returns the access mode, i.e., the metadata functions, which this image supports for the metadata type metadataId.

Parameters:

  | metadataId | The metadata identifier.

Returns:
  Access mode for the requested image type and metadata identifier.

The documentation for this class was generated from the following file:

- image.hpp